'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _pundleApi = require('pundle-api');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (0, _pundleApi.createTransformer)(function () {
  var _ref = _asyncToGenerator(function* (context, config, file) {
    if (!(0, _pundleApi.shouldProcess)(context.config.rootDirectory, file.filePath, config)) {
      return null;
    }

    var babelPath = config.babelPath;
    try {
      babelPath = yield context.resolve(babelPath, null, true);
    } catch (_) {
      throw new _pundleApi.MessageIssue('Unable to find babel-core. Please install it in your project root (transformer-babel)', 'error');
    }

    var babel = require(babelPath);

    var processed = void 0;
    try {
      processed = babel.transform(file.getContents(), Object.assign({}, config.config, {
        filename: file.filePath,
        sourceMap: true,
        highlightCode: false,
        sourceFileName: file.filePath
      }));
    } catch (error) {
      if (error.loc) {
        throw new _pundleApi.FileIssue(file.getFilePath(), file.getContents(), error.loc.line, error.loc.column + 1, error.message, 'error');
      } else {
        throw new _pundleApi.FileMessageIssue(file.getFilePath(), error.message);
      }
    }
    var contents = processed.code;
    var sourceMap = processed.map;

    return { contents: contents, sourceMap: sourceMap };
  });

  return function (_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}(), {
  babelPath: 'babel-core',

  config: {},
  extensions: [],
  exclude: [/(node_modules|bower_components)/]
});